#include <stdio.h>
#include <stdlib.h>

#ifdef ENABLE_CAPTURE
#include "capture.h"
#endif

#include "globals.h"
#include "functions.h"

/*

This code is copyright 2004-2007 by Michael Kohn
You may not use any of this program in your own programs
without permission from Michael Kohn <mike@mikekohn.net>

*/

/*
HTTP/1.1 200 OK
Date: Sat, 08 Oct 2005 01:51:33 GMT
Server: Apache/2.0.52 (Unix) PHP/5.0.3 mod_perl/2.0.0 Perl/v5.8.6
Last-Modified: Sat, 08 Oct 2005 01:51:05 GMT
ETag: "98469-e0fb-40294641ed440"
Accept-Ranges: bytes
Content-Length: 57595
Connection: close
Content-Type: image/jpeg
*/

int send_header(int ID)
{
// struct tm mod_tm;
char temp_string[256];

  //  gmtime_r(&users[ID]->last_modified,&mod_tm);


  message(ID,"HTTP/1.1 200 OK\r\n"
             "Server: "VERSION"\r\n"
             "Cache-Control: no-cache\r\n"
             "Pragma: no-cache\r\n"
             "Last-Modified: Wed, 29 May 1974 07:00:00 GMT\r\n"
             "Connection: Keep-Alive\r\n");
  // sprintf(temp_string,"Last-Modified: %s\r\n",ctime(&users[ID]->last_modified));
/*
  sprintf(temp_string,"Last-Modified: %s, %02d %s %d %02d:%02d:%02d GMT\r\n",
            days[mod_tm.tm_wday],
            mod_tm.tm_mday,
            months[mod_tm.tm_mon],
            mod_tm.tm_year+1900,
            mod_tm.tm_hour,
            mod_tm.tm_min,
            mod_tm.tm_sec);

printf("%s\n",temp_string);
  message(ID,temp_string);
*/

  sprintf(temp_string,"Content-Length: %ld\r\nContent-Type: %s\r\n\r\n",users[ID]->content_length,mime_types[users[ID]->mime_type]);
  message(ID,temp_string);

  // users[ID]->need_header=NEED_HEADER_NO;

  return 0;
}

#ifdef ENABLE_CGI
int send_header_cgi(int ID)
{

  message(ID,"HTTP/1.1 200 OK\r\n"
             "Server: "VERSION"\r\n"
             "Cache-Control: no-cache\r\n"
             "Pragma: no-cache\r\n"
             "Last-Modified: Wed, 29 May 1974 07:00:00 GMT\r\n"
             "Connection: Close\r\n");

  /* biggest cgi can be only 24 megs */
  users[ID]->content_length=1<<24;

  return 0;
}
#endif

#ifdef ENABLE_PLUGINS
int send_header_plugin(int ID)
{

  message(ID,"HTTP/1.1 200 OK\r\n"
             "Server: "VERSION"\r\n"
             "Cache-Control: no-cache\r\n"
             "Pragma: no-cache\r\n"
             "Last-Modified: Wed, 29 May 1974 07:00:00 GMT\r\n");

  /* biggest cgi can be only 24 megs */
  users[ID]->content_length=1<<24;

  return 0;
}
#endif

int send_header_multipart(int ID)
{
char temp_string[512];

  message(ID,"HTTP/1.0 200 OK\r\n"
             "Cache-Control: no-cache\r\n"
             "Pragma: no-cache\r\n"
             "Expires: Thu, 01 Dec 1994 16:00:00 GMT\r\n"
             "Connection: Close\r\n"
             "Content-Type: multipart/x-mixed-replace; boundary=--myboundary\r\n\r\n");

  sprintf(temp_string,"--myboundary\r\nContent-Type: image/jpeg\r\nContent-Length: %ld\r\n\r\n",users[ID]->content_length);
  message(ID,temp_string);

/*
  users[ID]->need_header=NEED_HEADER_YES;
  users[ID]->need_header=NEED_HEADER_NO;
*/
  users[ID]->request_type=REQUEST_MULTIPART2;

  return 0;
}

int send_error(int ID, char *short_error, char *error, int len)
{
char temp[1024];

  sprintf(temp,"HTTP/1.1 %s\r\n"
               "Server: "VERSION"\r\n"
               "Connection: Keep-Alive\r\n"
               "Content-Type: text/html\r\n"
               "Content-Length: %d\r\n\r\n",short_error,len);
  message(ID,temp);

  /* send_data(users[ID]->socketid,FOUR_OH_FOUR,sizeof(FOUR_OH_FOUR)); */
  send_data(users[ID]->socketid,error,len);

  users[ID]->video_num=-1;
  users[ID]->state=STATE_IDLE;

  return 0;
}

int send_401(int ID)
{
char tempString[32];

  message(ID,"HTTP/1.1 401 Authorization Required\r\n"
             "Server: "VERSION"\r\n"
             "Connection: Keep-Alive\r\n"
             "WWW-Authenticate: Basic realm \"nakenweb\"\r\n"
             "Content-Type: text/html\r\n");
  sprintf(tempString,"Content-Length: %d\r\n\r\n",(int)sizeof(FOUR_OH_ONE));
  message(ID,tempString);

  send_data(users[ID]->socketid,FOUR_OH_ONE,sizeof(FOUR_OH_ONE));

  users[ID]->video_num=-1;
  users[ID]->state=STATE_IDLE;

  if (users[ID]->in!=-1)
  {
    /* fclose(users[ID]->in); */
    file_close(ID);
  }

  return 0;
}

int send_video_error(int ID)
{
char tempString[32];

  message(ID,"HTTP/1.1 200 OK\r\n"
             "Server: "VERSION"\r\n"
             "Connection: Keep-Alive\r\n"
             "Content-Type: text/html\r\n");
  sprintf(tempString,"Content-Length: %d\r\n\r\n",(int)sizeof(VIDEO_ERROR));
  message(ID,tempString);

  send_data(users[ID]->socketid,VIDEO_ERROR,sizeof(VIDEO_ERROR));

  users[ID]->video_num=-1;
  users[ID]->state=STATE_IDLE;

  return 0;
}

