#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "globals.h"
#include "functions.h"

/* url_decode s without allocating any new memory */

int url_decode(unsigned char *s)
{
int sptr,dptr;
int c,t;

  sptr=0;
  dptr=0;

  while(s[sptr]!=0)
  {
    if (s[sptr]=='%')
    {
      c=0;
      for (t=0; t<2; t++)
      {
        sptr++;
        if (s[sptr]>='0' && s[sptr]<='9')
        { c=(c<<4)+(s[sptr]-'0'); }
          else
        if (tolower(s[sptr])>='a' && tolower(s[sptr])<='f')
        { c=(c<<4)+(tolower(s[sptr])-'a'); }
          else
        {
          s[dptr]=0;
          return -1;
        }
      }

      if (c>=32) s[dptr]=c;
    }
      else
    {
      s[dptr]=s[sptr];
    }

    dptr++; sptr++;
  }

  s[dptr]=0;

  return 0;
}

char *get_querystring(char *filename)
{
int ptr;

  ptr=0;

  while(filename[ptr]!='?' && filename[ptr]!=0) ptr++;

  if (filename[ptr]==0) return filename+ptr;

  filename[ptr]=0;

  return filename+ptr+1;
}

int parse_querystring(int ID, char *filename, struct alias_t *curr_alias)
{
int ptr,r;
char name[256];
char value[256];
int state;

  ptr=0;

  while(filename[ptr]!='?' && filename[ptr]!=0) ptr++;
  if (filename[ptr]==0) return -1;

  filename[ptr]=0;
  ptr++;

  r=0;
  state=0;

  while(1)
  {
    if (state==0)
    {
      if (filename[ptr]==0) break;

      if (filename[ptr]=='=')
      {
        name[r]=0;
        r=0;
        state=1;
        ptr++;
        continue;
      }

      name[r++]=filename[ptr++];
    }
      else
    {
      if (filename[ptr]=='&' || filename[ptr]==0)
      {
        value[r]=0;
        r=0;
        state=0;

        if (curr_alias->port_param!=0 && strcasecmp(name,curr_alias->port_param)==0)
        { users[ID]->video_num=atoi(value)-1; }  /* This might be a problem */
          else
        if (curr_alias->fps_param!=0 && strcasecmp(name,curr_alias->fps_param)==0)
        { users[ID]->frame_rate=atoi(value); }
#ifdef V4L2
          else
        if (curr_alias->comp_param!=0 && strcasecmp(name,curr_alias->comp_param)==0)
        { users[ID]->jpeg_quality=atoi(value); }
#endif

        if (filename[ptr]==0) break;
        ptr++;
        continue;
      }

      value[r++]=filename[ptr++];
    }
  }

  if (users[ID]->video_num<0) users[ID]->video_num=VIDEO_NUM_404;

  return 0;
}

int check_valid_file(char *s)
{
int ptr,c;

  c=0;
  ptr=0;
  
  while(s[ptr]!=0)
  {
    if (s[ptr]=='.')
    { c++; }
      else 
    { c=0; }
    
    if (s[ptr]=='~') return -1;

    if (c==2) return -1;

    ptr++;
  }

  return 0;
}


int get_mime_type_code(char *s)
{
#ifdef ENABLE_CGI
struct cgi_handler_t *curr_handler;
#endif
int l,t;

  l=strlen(s)-1;

  while(l>0)
  {
    if (s[l]=='.') break;
    l--;
  }

  if (s[l]!='.') return 0;

  l++;

  t=0;
  while(extensions[t]!=0)
  {
    if (strcasecmp(s+l,extensions[t])==0) return mime_type_code[t];
    t++;
  }

#ifdef ENABLE_CGI
  t=32768;
  curr_handler=cgi_handler;
  while(curr_handler!=0)
  {
    if (strcasecmp(s+l,curr_handler->extension)==0) return t;
    curr_handler=curr_handler->next_handler;
    t++;
  }
#endif

  return 0;
}




